/*  https://radioman.com.ua/viewtopic.php?p=190#p190   */

#include "DHT.h"                           // підключення бібліотеки датчика
#define DHTPIN 2                           // номер піна даних
DHT dht(DHTPIN, DHT22);                    // пін підключення та тип датчика

#include <Adafruit_SSD1306.h>               // підключення бібліотеки для SSD1306

#define OLED_RESET 7
Adafruit_SSD1306 display(OLED_RESET);       // створюємо об'єкт "дисплей"

void setup()
{
  dht.begin();                               // ініціалізація датчика

  /* setup дисплея */
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // ініціалізація дисплея по інтерфейсу I2C, адреса 0x3C
  display.clearDisplay();                    // очистка дисплея
  display.setTextSize(2);                    // размір шрифту (1,2,3,4)
  display.setTextColor(WHITE);               // колір тексту
}
void loop()
{
  delay(2000);                                // 2 секунди затримки (максимальна частота опитування датчика DHT22 - 0.5 герц)
  float h = dht.readHumidity();               // вимірювання вологості
  float t = dht.readTemperature();            // вимірювання температури

  /* Перевірка: якщо не вдається зчитати показники, виводиться «Помилка зчитування», і програма завершується */
  if (isnan(h) || isnan(t))
  {
    display.clearDisplay();                    // очистка буферу дисплея
    display.display();                         // виводимо на екран (очищаємо екран)

    display.setCursor(12, 10);                 // встановлюємо курсор в позицію X = 12; Y = 10
    display.print ("ERROR DHT");               // записуємо в буфер повідомлення про помилку датчика
    display.display();                         // виводимо на екран
    
    return;
   }
/* Вивід показників на дисплей */
    display.clearDisplay();                     // очистка буферу дисплея
    
    display.setCursor(0, 0);                    // встановлюємо курсор в позицію X = 0; Y = 0 (верхній лівий кут)
    display.print ("H = ");                     // записуємо в буфер позначення вологості
    display.print (h);                          // записуємо в буфер значення вологості

    display.setCursor(0, 18);                   // встановлюємо курсор в позицію X = 0; Y = 18 (другий рядок)
    display.print ("T = ");                     // записуємо в буфер позначення температури
    display.print (t);                          // записуємо в буфер значення температури
    display.display();                          // очищаємо екран
    display.display();                          // виводимо дані на дисплей
}
